#include "color.h"
#include "display.h"

#define VIDEO_MODE_REG (*(volatile unsigned short *)(0x04000000))
#define VIDEO_MODE_3 0x0F03

#define VRAM ((volatile unsigned short (*)[240])0x06000000)

void display_init(void)
{
	int x;
	int y;

	for (y = 0; y < DISPLAY_Y; y++) {
		for (x = 0; x < DISPLAY_X; x++) {
			VRAM[y][x] = COLOR_WHITE;
		}
	}

	VIDEO_MODE_REG = VIDEO_MODE_3;
}

void print_text(int line, int column, char *text)
{
	char c;
	int x;
	int y;
	int vram_x;
	int vram_y;

	while ((c = *text++) != '\0') {
		for (y = 0; y < FONT_Y; y++) {
			for (x = 0; x < FONT_X; x++) {
				vram_y = y + line * FONT_Y; 
				vram_x = x + column * FONT_X;
				VRAM[vram_y][vram_x] = font[c][y][x];
			}
		}
		if (++column >= COLUMNS) {
			column = 0;
			if (++line >= LINES) {
				line = 0;
			}
		}
	}
}
